using DevExpress.Mvvm.Native;
using PMCommon.Interface.DataBase;
using PMCommon.Interface.Device;
using PMCore.Data;
using System.Collections.Generic;
using System.Runtime.Serialization.Formatters.Binary;
using Newtonsoft.Json;
using System.Text;
using System.Reflection;
using DevExpress.Xpf.Printing;

namespace TestDataToFile
{
    [TestClass]
    public class TestDataToFile
    {

        [TestMethod]
        public void TestWriteDicToJson()
        {
            var keyValuePairs = new Dictionary<Type, Dictionary<int, IDBCreator>>();
            var subDictDevices = new Dictionary<int, IDBCreator>();
            var subDictConnections = new Dictionary<int, IDBCreator>();

            IDevice aaa = new Device() { Name = "aaa" };
            IDevice ccc = new Device() { Name = "ccc" };
            IDevice ddd = new Device() { Name = "ddd" };
            IConnection bbb = new DeviceConnection() { Name = "bbb" };
            IConnection ggg = new DeviceConnection() { Name = "ggg" };
            subDictDevices.Add(0, aaa);
            subDictConnections.Add(0, bbb);
            subDictConnections.Add(1, ggg);
            subDictDevices.Add(1, ccc);
            subDictDevices.Add(2, ddd);
            keyValuePairs.Add(aaa.GetType(), subDictDevices);
            keyValuePairs.Add(bbb.GetType(), subDictConnections);

            File.WriteAllText("DicFile.json", JsonConvert.SerializeObject(keyValuePairs));
        }

        [TestMethod]
        public void TestReadDicToJson()
        {
            var mainDict = new Dictionary<Type, Dictionary<int, IDBCreator>>();
            var obj = new object();

            var Loaded_Dictionary = JsonConvert.DeserializeObject<Dictionary<Type, Dictionary<int, object>>>(File.ReadAllText("DicFile.json"));
            var dicKey = Loaded_Dictionary.Keys;

            foreach (var item in dicKey)
            {
                if (item is null)
                {
                    break;
                }
                string strType = item.FullName + ", " + item.Assembly;
                Type type = Type.GetType(strType); // null exception warning
                if (type is null)
                {
                    break;
                }

                if (Loaded_Dictionary[type].Keys.Count > 0)
                {
                    Dictionary<int, IDBCreator> aaa = new Dictionary<int, IDBCreator>();

                    foreach (var subKey in Loaded_Dictionary[type].Keys)
                    {
                        Loaded_Dictionary[type].TryGetValue(subKey, out obj);
                        var sDevice = obj.ToString();
                        var person = JsonConvert.DeserializeObject(sDevice, type);

                        aaa.Add(subKey, person as IDBCreator);

                    }
                    mainDict.Add(type, aaa);
                }
            }

        }

        //[TestMethod]
        //public void TestReadAAA()
        //{
        //    var Loaded_Dictionary = JsonConvert.DeserializeObject<Dictionary<Type, Dictionary<int, object>>>(File.ReadAllText("DicFile.json"),
        //        new
        //        {
        //            Dictionary<int, IDBCreator> subDict = new Dictionary<int, IDBCreator>()
        //        });
        //}



        //[TestMethod]
        //public void TestWriteData()
        //{
        //    var keyValuePairs = new Dictionary<Type, Dictionary<int, IDBCreator>>();
        //    var subDict = new Dictionary<int, IDBCreator>();

        //    subDict.Add(0, new Device() { Name = "00" });   
        //    subDict.Add(1, new Device() { Name = "11" });
        //    IDevice aaa = new Device();
        //    subDict.Add(0, aaa);

        //    //keyValuePairs[aaa.GetType()] = subDict;

        //    //keyValuePairs.Add(typeof(Dictionary<int, IDBCreator>), subDict);
        //    keyValuePairs.Add(aaa.GetType(), subDict);
        //    //Dictionary<string, int> dict = new Dictionary<string, int>();
        //    //dict.Add("banana", 20); 
        //    //dict.Add("cherry", 30);
        //    using (StreamWriter writer = new StreamWriter("output.txt"))
        //    {
        //        foreach (KeyValuePair<Type, Dictionary<int, IDBCreator>> entry in keyValuePairs) 
        //        {
        //            foreach (KeyValuePair<int, IDBCreator> item in entry.Value)
        //            {
        //                var value = item.Value as Device;
        //                writer.WriteLine($"{entry.Key}:{item.Key}={value.Name}");
        //            }
        //            //writer.WriteLine($"{entry.Key}\n{entry.Value}");
        //        }
        //    }
        //}

        //[TestMethod]
        //public void TestReadData()
        //{
        //    var keyValuePairs = new Dictionary<Type, Dictionary<int, IDBCreator>>();
        //    var subDict = new Dictionary<int, IDBCreator>();
        //    using (StreamReader reader = new StreamReader("output.txt"))
        //    {
        //        string line;
        //        while ((line = reader.ReadLine()) != null)
        //        {
        //            string[] parts = line.Split(':');
        //            string typeKey = parts[0];
        //            Type type = Type.GetType(typeKey);
        //            string[] sDevice = parts[1].Split('=');
        //            string devKey = sDevice[0];
        //            string devValue = sDevice[1];
        //            Device value = new Device { Name = devValue };
        //            subDict[Int32.Parse(devKey)] = value;
        //            keyValuePairs[type] = subDict;
        //        }
        //    }
        //}

        //[TestMethod]
        //public void TestWriteBin()
        //{
        //    var keyValuePairs = new Dictionary<Type, Dictionary<int, IDBCreator>>();
        //    var subDict = new Dictionary<int, IDBCreator>();

        //    IDevice aaa = new Device();
        //    subDict.Add(0, aaa);
        //    keyValuePairs.Add(aaa.GetType(), subDict);

        //    string filePath = "data.bin";
        //    using (BinaryWriter writer = new BinaryWriter(File.Open(filePath, FileMode.Create)))
        //    {
        //        // write the number of types in the dictionary as an integer
        //        writer.Write(keyValuePairs.Count);
        //        // write each type and its corresponding dictionary to the file
        //        foreach (KeyValuePair<Type, Dictionary<int, IDBCreator>> typePair in keyValuePairs)
        //        {
        //            // write the type name as a string
        //            writer.Write(typePair.Key.GetType().ToString());
        //            // write the number of items in the dictionary as an integer
        //            writer.Write(typePair.Value.Count);
        //            // write each item to the file
        //            foreach (KeyValuePair<int, IDBCreator> item in typePair.Value)
        //            {
        //                //write the key as an unsigned integer
        //                writer.Write(item.Key);
        //                //write the value as an IDBCreator object
        //                //(you may need to modify this part based on the implementation of IDBCreator)
        //                byte[] data;
        //                BinaryFormatter bf = new BinaryFormatter();
        //                using (MemoryStream ms = new MemoryStream())
        //                {
        //                    bf.Serialize(ms, item.Value);
        //                    data = ms.ToArray();
        //                }

        //                //byte[] data = item.Value.ToByteArray(); 
        //                writer.Write(data.Length); 
        //                writer.Write(data);
        //            }
        //        }
        //    }
        //}
    }
}